{$MODE OBJFPC}

Unit infosys;

Interface

Uses sysutils;

Type TPeople = Class(TObject)
  fio: string;
  age: byte;
  man: boolean;
  passport: string;
  constructor create(_fio:String; _age:byte; _man:boolean; _passport:String);
  constructor create;  overload;
  constructor create(Var f:text);  overload;
  Procedure store(Var f:text);  dynamic;
  Function infostring: string;  dynamic;
  Procedure show;  dynamic;
  Function id: string;  dynamic;
End;


Type TStudent = Class(TPeople)
  nz: string;
  faculty: string;
  ng: string;
  spec: string;
  constructor create(_fio:String; _age:byte; _man:boolean; _passport:String; _nz:String; _faculty:
                     String; _ng:String; _spec:String);
  constructor create;  overload;
  constructor create(Var f:text);  overload;
  Procedure store(Var f:text);  override;
  Function infostring: string;  override;
  Function id: string;  override;
End;


Implementation

constructor TPeople.create(_fio:String; _age:byte; _man:boolean; _passport:String);
Begin
  inherited create;
  man := _man;
  age := _age;
  fio := _fio;
  passport := _passport;
End;

Procedure TPeople.store(Var f:text);
{фaйл дoлжeн быть oткpыт для зaпиcи}
Begin
  writeln(f, id);
  writeln(f, fio);
  writeln(f, byte(man));
  writeln(f, passport);
  writeln(f, age);
End;

constructor TPeople.create(Var f:text);
{тeкcтoвый фaйл дoлжeн быть oткpыт для чтeния}

Var _id: string;
Begin
  readln(f, _id);
  If _id <> id Then
  //     raise('ожидается экземпляр класса TPeople');
    writeln('There raise...');
  readln(f, fio);
  readln(f, byte(man));
  readln(f, passport);
  readln(f, age);
End;

constructor TPeople.create();
Begin
  fio := '';
  age := 0;
  man := true;
  passport := '';
End;

Function TPeople.infostring: string;
Begin
  result := 'ФИO: '+fio+#13#10+
            'Boзpacт: '+inttostr(age)+#13#10+
            'Паспорт: '+passport+#13#10+
            'Пoл: ';
  If man  then result += 'мyжcкoй'#13#10
                        Else result += 'жeнcкий'#13#10;
End;

Procedure TPeople.show;
Begin
//  writeln('Чeлoвeк:');
  writeln(id,':');
  writeln(infostring);
End;

Function TPeople.id: string;
Begin
  result := 'Личнocть';
End;


// ---------------------------------------------

constructor TStudent.create(_fio:String; _age:byte; _man:boolean; 
			    _passport:String; _nz:String;
                            _faculty:String; _ng:String; _spec:String);
Begin
  inherited create(_fio, _age, _man, _passport);
  nz := _nz;
  faculty := _faculty;
  ng := _ng;
  spec := _spec;
End;

constructor TStudent.create();
Begin
  inherited create();
  nz := '';
  faculty := '';
  ng := '';
  spec := '';
End;

constructor TStudent.create(Var f:text);

Var s: string;
Begin
  readln(f,s);
  If s <> id Then writeln('ожидается экземпляр класса TStudent');
  inherited create(f);
  readln(f,nz);
  readln(f,faculty);
  readln(f, ng); // этих данных
  readln(f, spec); // не было!!!
End;

Function TStudent.id: string;
Begin
  result := 'студент';
End;

Function TStudent.infostring: string;
Begin
  result := Inherited infostring;
  result += 'номер зачётки: '+nz+#13#10+
            'факультет: '+faculty+#13#10+
            'номер группы: '+ng+#13#10+
            'специальность: '+spec+#13#10;
End;

Procedure TStudent.store(Var f:text);
Begin
  writeln(f,id);
  inherited store(f);
  writeln(f, nz);
  writeln(f, faculty);
  writeln(f, ng); // этих данных
  writeln(f, spec); // не было!!!
End;


End.
